<template>
  <div class="cart-products">
    <div class="cart-nav-wrapper ">
      <ul class="cart-nav container">
        <li :class="{'active': activePage === 'cart-products'}" @click="activePage = 'cart-products'">
          В Корзине
        </li>
        <li v-if="fullCartProducts && fullCartProducts.length > 0" :class="{'active': activePage === 'checkout'}" @click="activePage = 'checkout'">
          Оформить заказ
        </li>
      </ul>
    </div>
    <div class="container mt-5" v-if="activePage === 'cart-products'">
      <div class="cart-container">
        <div class="cart-items-wrapper">
          <div class="mb-2 d-flex cart-item" v-if="fullCartProducts && fullCartProducts.length > 0" v-for="item in fullCartProducts" >
            <div class="bg-image-animate cart-product" v-on:click="navigateProductDetail(item)">
              <div
                class="product-img"
                alt="Card image cap"
                :style="`background-image: url('${getImageUrl(item)}')`"
                >
              </div>

              <div
                class="product-img"
                :style="`background-image: url('${getImageUrl(item, true)}')`"
                alt="Card image cap"
                >
              </div>
            </div>
            <div class="product-body">
              <h6 class="card-text">{{item.productName}} <span class="remove-item-i" v-on:click="removeProductCart(item)"></span></h6>
              <p>Size: <span v-text="item.item.type"></span></p>

              <div class="d-flex card-price">
                <p class="product-price" :class="{'old-price': item.discount}" v-text="getPrice(item)"></p>
                <p v-if="item.discount" class="ml-2 product-price discount-price" v-text="getPrice(item, true)"></p>
              </div>
            </div>

          </div>
          
          <div v-if="!fullCartProducts || fullCartProducts.length < 1">
            <div class="empty-cart container">
              <h3>Корзина пуста.</h3>
              <button class="action-button main-button" @click="$router.push('/products')">В МАГАЗИН</button>
            </div>
          </div>
        </div>
        <div class="cart-details-wrapper" v-if="fullCartProducts && fullCartProducts.length > 0">
          <div class="cart-prices" v-if="fullCartProducts">
            <ul class="list-group mb-3">
              <li
                class="d-flex justify-content-between lh-condensed cart-product-wrapper"
                v-for="(product, index) in fullCartProducts"
                :key="index"
              >
                <div>
                  <h6 class="my-0">{{product.productName}} ({{product.item.type}})</h6>
                </div>

                <div class="d-flex cart-item-price">
                  <p class="product-price" :class="{'old-price': product.discount || product.item.discountPrice}" v-text="getPrice(product)"></p>
                  <p v-if="product.discount || product.item.discountPrice" class="ml-2 product-price discount-price" v-text="getPrice(product, true)"></p>
                </div>
              </li>
              <hr>
              <p class="mb-1" v-if="activePromoCode">PROMO CODE: <span class="pull-right bold text-success">- {{activePromoCode.discount}} %</span></p>
              <li class="d-flex justify-content-between">
                <span>Всего ({{cartProducts.length}} items)</span>
                <span>{{totalValue.toFixed(2)}} ГРН</span>
              </li>
            </ul>
          </div>

          <ul class="list-group mb-3">
            <div>
              <p class="errorMessage" v-if="error" v-text="error"></p>
              <div class="promo-wrapper">
                <input type="text" class="promo-input" v-model="promoCode" placeholder="PROMO CODE">
                <button class="action-button gray-button promo-button" @click="applyPromo">ПРИМЕНИТЬ</button>
              </div>
            </div !important>
            <button class="action-button main-button" @click="goTo('products')">Продолжить Покупки</button>
            <button class="action-button black-button" @click="activePage = 'checkout'">Оформить Заказ</button>
          </ul>
        </div>
      </div>
    </div>
    <checkout v-if="activePage === 'checkout'" :totalPrice="totalValue" :promoCode="activePromoCode"></checkout>
  </div>
  
</template>

<script>
import { mapMutations } from "vuex";
import Checkout from "./Checkout";

import CardTemplate from "@/components/shared/CardTemplate";

export default {
  name: "CartProducts",
  components: { Checkout, CardTemplate },
  data() {
    return {
      promoCode: '', error: '',
      cartProducts: undefined, fullCartProducts: undefined, activePromoCode: undefined,
      activePage: 'cart-products',
      totalValue: 0.0
    };
  },
  methods: {
    ...mapMutations(["SET_CART_PRODUCTS"]),
    calulateTotalPrice() {
      this.totalValue = 0;
      this.fullCartProducts.forEach(product => {
        let price;

        if (product.discount) {
          price = parseFloat(product.item.price) - (product.item.price * (product.discount / 100));
        } else {
          price = product.item.discountPrice ? product.item.discountPrice : product.item.price;
        }
        this.totalValue += parseFloat(price);
      });
    },
    removeProductCart(product) {
      const products = JSON.parse(localStorage.getItem("iki-cart"));
      products.some((p, ind, arr) => {
        if (p.productId === product._id && p.cartItemId === product.cartItemId) {
          arr.splice(ind, 1);
        }
      });
      this.fullCartProducts.some((p, ind, arr) => {
        if (p._id === product._id && p.cartItemId === product.cartItemId) {
          arr.splice(ind, 1);
        }
      });
      this.SET_CART_PRODUCTS(products);
      localStorage.setItem("iki-cart", JSON.stringify(products));
    },
    getFullCartItems() {
      this.cartProducts = this.$store.getters.cartProducts;
      if (this.cartProducts.length >= 1) {
        let ids = this.cartProducts.map(c => c.productId).filter(c => c).join(',');
        this.$http.get(`${process.env.VUE_APP_BASE_URL}/products?ids=${ids}`)
          .then(products => {
            this.fullCartProducts = this.cartProducts.reduce((arr, cp) => {
              let fullCartItem = products.data.find(pr => pr._id === cp.productId);
              fullCartItem = JSON.parse(JSON.stringify(fullCartItem));
              if (!fullCartItem) return arr;
              let cartItem = fullCartItem.items.find(ci => ci._id === cp.selectedItem);
              if (Number(cartItem.quantity) > 0) {
                fullCartItem.item = cartItem;
                fullCartItem.cartItemId = cp.cartItemId;
                arr.push(fullCartItem);
              } else {
                return arr;
              }
              return arr;
            }, []);
            this.calulateTotalPrice();
            this.cartProducts = this.cartProducts.filter(c => this.fullCartProducts.map(c1 => c1._id).includes(c.productId));
            this.SET_CART_PRODUCTS(this.cartProducts);
            localStorage.setItem("iki-cart", JSON.stringify(this.cartProducts));
          })
          .catch(err => {
            console.log('err', err);
          });
      }
    },
    goTo(page) {
      this.$router.push(page);
    },
    getImageUrl(item, secondary) {
      if (secondary) return item.files.find(f => !f.main && !f.video).url;
      return item.files.find(f => f.main).url;
    },
    navigateProductDetail(product) {
      this.$router.push({
        name: "productDetails",
        params: { id: product._id }
      });
    },
    applyPromo(e) {
      this.error = '';
      if (this.promoCode) {
        e.target.disabled = true;
        this.$http.get(`${process.env.VUE_APP_BASE_URL}/promo-codes/${this.promoCode}`).then(resp => {
          this.activePromoCode = resp.data;
          this.fullCartProducts.forEach(product => {
            if (this.activePromoCode.categories.includes(product.productCategory)) {
              product.item.discount = this.activePromoCode.discount;
              product.item.discountPrice = parseFloat(product.item.price) - (product.item.price * (this.activePromoCode.discount / 100));
            }
          });
          this.calulateTotalPrice();
          e.target.disabled = false;
          this.promoCode = '';
        }).catch(err => {
          console.log(err);
          e.target.disabled = false;
          this.promoCode = '';
          this.error = 'Промокод не найден';
        })
      }
    },
    getPrice(product, discount) {
      if (discount) {
        if (product.discount) {
          let price = product.item.price;

          price = parseFloat(price) - (price * (product.discount / 100));
          return `${price} UAH`;
        } else {
          return `${product.item.discountPrice} UAH`;
        }
      } else {
        let price = product.item.price;
        return `${price} UAH`;
      }
    }
  },
  mounted() {
    this.getFullCartItems();
  },
  watch: {
    'fullCartProducts': {
      handler: function (val, oldVal) {
        this.calulateTotalPrice();
      },
      deep: true
    }
  }
};
</script>

<style lang="scss">
.cart-products {
  margin-top: 70px;
  padding-top: 20px;
  background-color: #fbfbfb;
}
.cart-nav-wrapper {
  background-color: #ede8d7;
  color: gray;
  .cart-nav {
    display: flex;
    li {
      min-height: 60px;
      min-width: 175px;
      line-height: 58px;
      font-size: 16px;
      text-align: center;
      cursor: pointer;
      &.active {
        background-color: #907f5e;
        color: #fff;
      }
    }

  }
}
.error-template {
  padding: 40px 15px;
  text-align: center;
}

.error-actions {
  margin-top: 15px;
  margin-bottom: 15px;
}

.error-actions .btn {
  margin-right: 10px;
}

.product-body p {
  font-size: 14px;
}
.product-body .remove-item-i {
  background-image: url('../../../assets/cross.svg');
  background-size: cover;
  cursor: pointer;
  background-position: center;
  height: 15px;
  width: 15px;
  display: inline-block;
  float: right;
}
.empty-cart {
  margin: 0 auto 40px;
}

.promo-wrapper {
  display: flex;
  .promo-input {
    width: 70%;
    padding: 5px;
  }
  .promo-button {
    width: 38%;
    margin-top: 0;
  }
}

.cart-product-wrapper {
  display: flex;
  justify-content: space-between;
  & > div {
    width: 59%;
  }
  .cart-item-price {
    width: 49%;
    font-size: 16px;
    display: flex;
    justify-content: flex-end;
  }

  .product-price {
    margin-bottom: 0;
  }
  @media (max-width: 768px) {
    & > div {
      width: 49%;
    }

    .cart-item-price {
      width: 50%;
      
    }

  }
}

.cart-container {
  display: flex;
  justify-content: space-between;

  .cart-items-wrapper {
    width: 49%;
    .cart-item {
      border: 1px solid #eaeaea;
    }
    .cart-product {
      width: 100%;
      max-width: 150px;
      max-height: 150px;
      min-height: 150px;

      .product-img {
        height: 150px;
      }
    }
    .product-body {
      width: 100%;
      background-color: #fff;
    }
  }

  .cart-details-wrapper {
    width: 49%;
    .cart-prices {
      ul {
        padding: 10px;
        border: 1px solid #eaeaea;
        background-color: #fff;
      }
    }
  }
}
@media (max-width: 992px) {
  .cart-products {
    margin-top: 0;
  }
  .cart-container {
    display: flex;
    justify-content: space-between;
    flex-direction: column;

    .cart-items-wrapper {
      width: 100%;
    }

    .cart-details-wrapper {
      width: 100%;
    }
  }
}

</style>
